#include <stdint.h>
#include <string.h>
#include "deq_int.h"

//-------------------------------------------------------------------------------------------------------------------------

// LemireMaxClampedFilter streaming max over window
// implementation for "Daniel Lemire, Streaming Maximum-Minimum Filter Using No More than Three Comparisons per Element. Nordic Journal of Computing, 13 (4), pages 328-339, 2006."
// preprint https://arxiv.org/abs/cs.DS/0610046
// source https://github.com/lemire/runningmaxmin

typedef struct LemireMaxClampedFilter {
    int windowSize;
    int dataToFilterSize;
    deq_int fifo;
    float* dataToFilter;
} LemireMaxClampedFilter;

LemireMaxClampedFilter* lemire_max_clamped_init(int windowSize, int dataLength);

void lemire_max_clamped_free(LemireMaxClampedFilter* l);

void lemire_max_clamped_filter(LemireMaxClampedFilter* l, float* restrict array, size_t array_size, float* restrict max);